'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports['default'] = perf;

var _reactAddonsPerf = require('react-addons-perf');

var _reactAddonsPerf2 = _interopRequireDefault(_reactAddonsPerf);

var _validators = require('../../utils/validators');

var _wrapLifecycleMethod = require('../../utils/wrapLifecycleMethod');

var _wrapLifecycleMethod2 = _interopRequireDefault(_wrapLifecycleMethod);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var capitalizeFirstLetter = function capitalizeFirstLetter(str) {
  return '' + str.charAt(0).toUpperCase() + str.slice(1);
};

var printMeasurements = function printMeasurements(prints) {
  var measurements = _reactAddonsPerf2['default'].getLastMeasurements();
  prints.forEach(function (x) {
    var attr = 'print' + capitalizeFirstLetter(x);
    if (_reactAddonsPerf2['default'][attr]) {
      _reactAddonsPerf2['default'][attr](measurements);
    }
  });
};

//eslint-disable-next-line
function perf() {
  var _ref = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

  var _ref$prints = _ref.prints;
  var prints = _ref$prints === undefined ? [] : _ref$prints;
  var _ref$event = _ref.event;
  var event = _ref$event === undefined ? 'mount' : _ref$event;

  return function (target, key, descriptor) {
    (0, _validators.validateClassAndFunction)(descriptor && descriptor.value || target, 'perf');
    var newFunction = void 0;

    if (target.prototype && target.prototype.isReactComponent && !(descriptor && descriptor.value)) {
      (0, _wrapLifecycleMethod2['default'])('componentWill' + capitalizeFirstLetter(event), _reactAddonsPerf2['default'].start)(target);
      (0, _wrapLifecycleMethod2['default'])('componentDid' + capitalizeFirstLetter(event), function () {
        _reactAddonsPerf2['default'].stop();
        printMeasurements(prints);
      })(target);
      newFunction = target;
    } else {
      (function () {
        var userFunc = descriptor.value;
        newFunction = _extends({}, descriptor, {
          value: function perfMeasurer() {
            _reactAddonsPerf2['default'].start();

            for (var _len = arguments.length, params = Array(_len), _key = 0; _key < _len; _key++) {
              params[_key] = arguments[_key];
            }

            var result = userFunc.apply(this, [].concat(params));
            _reactAddonsPerf2['default'].stop();
            printMeasurements(prints);
            return result;
          }
        });
      })();
    }
    return newFunction;
  };
}