'use strict';

exports.__esModule = true;
exports['default'] = wrapLifecycleMethod;
function wrapLifecycleMethod(method, func) {
  return function (target) {
    var originalComponentLifecycle = target.prototype[method];
    Object.defineProperty(target.prototype, method, {
      value: typeof originalComponentLifecycle === 'function' ? function componentLifecycleWrapper() {
        for (var _len = arguments.length, params = Array(_len), _key = 0; _key < _len; _key++) {
          params[_key] = arguments[_key];
        }

        var result = originalComponentLifecycle.apply(this, [].concat(params));
        return func.apply(this, [].concat(params, [result]));
      } : function componentLifecycleWrapper() {
        for (var _len2 = arguments.length, params = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
          params[_key2] = arguments[_key2];
        }

        return func.apply(this, [].concat(params));
      }
    });
  };
}